import 'package:flutter/material.dart';
import 'package:tivio_sdk/tivio.dart';
import 'package:flutter_dotenv/flutter_dotenv.dart';

class TivioVideoPage extends StatefulWidget {
  final TivioDataVideo _tivioDataVideo;

  TivioVideoPage(this._tivioDataVideo);

  @override
  _TivioVideoPageState createState() => _TivioVideoPageState();
}

class _TivioVideoPageState extends State<TivioVideoPage> {
  bool _isTivioInitialized = false;
  Tivio _tivio;

  @override
  void initState() {
    super.initState();
    initializeTivio();
  }

  initializeTivio() async {
    _tivio = await initTivio(DotEnv().env['TIVIO_SECRET']);

    setState(() {
      _isTivioInitialized = true;
    });
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text(this.widget._tivioDataVideo.name)),
      body: Container(
        child: (_isTivioInitialized)
            ? TivioPlayer(
                playerId: '1',
                tivio: _tivio,
                source: TivioPlayerChannelSource(
                  this.widget._tivioDataVideo.url.hls,
                  this.widget._tivioDataVideo.name,
                  Duration(),
                  this.widget._tivioDataVideo.duration,
                ),
              )
            : Text('initializing...'),
      ),
    );
  }
}
