import 'package:flutter/material.dart';
import 'package:nav_router/nav_router.dart';
import 'package:tivio_sdk/tivio.dart';
import './tivio_video_page.dart';

class TivioVideoWidget extends StatefulWidget {
  final TivioDataSection _tivioDataSection;

  TivioVideoWidget(this._tivioDataSection);

  @override
  _TivioVideoWidgetState createState() => _TivioVideoWidgetState();
}

class _TivioVideoWidgetState extends State<TivioVideoWidget> with TivioVideos {
  @override
  void initState() {
    super.initState();
    initializeTivioVideos(this.widget._tivioDataSection);
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.all(5),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Text(
            'videos:',
            style: TextStyle(
              fontSize: 18,
              fontWeight: FontWeight.bold,
            ),
          ),
          ...tivioVideos.entries
              .map((e) => MaterialButton(
                    child: Text(e.value.name),
                    onPressed:
                        (e.value.url.hls != null && e.value.url.hls != '')
                            ? () => _navigateToPage(TivioVideoPage(e.value))
                            : null,
                  ))
              .toList(),
        ],
      ),
    );
  }

  _navigateToPage(Widget page) {
    return routePush(page, RouterType.material);
  }
}
