import 'package:flutter/material.dart';
import 'package:tivio_sdk/tivio.dart';
import './tivio_channel_widget.dart';

class TivioWidgetsPage extends StatefulWidget {
  final Tivio _tivio;

  TivioWidgetsPage(this._tivio);

  @override
  _TivioWidgetsPageState createState() => _TivioWidgetsPageState();
}

class _TivioWidgetsPageState extends State<TivioWidgetsPage> with TivioWidgets {
  @override
  void initState() {
    super.initState();
    initializeTivioWidgets(this.widget._tivio);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text('Traverse data')),
      body: Container(
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            Text(
              'widgets:',
              style: TextStyle(
                fontSize: 18,
                fontWeight: FontWeight.bold,
              ),
            ),
            ...tivioWidgets.entries
                .map((e) => Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: [
                        Text(e.value.name),
                        TivioChannelWidget(e.value),
                      ],
                    ))
                .toList(),
          ],
        ),
      ),
    );
  }
}
