import 'package:flutter/material.dart';
import '../tivio.dart';
import '../dto.dart';

mixin TivioWidgets<T extends StatefulWidget> on State<T> {
  Tivio _tivio;
  var tivioWidgets = Map<String, TivioDataWidget>();

  initializeTivioWidgets (Tivio tivio) {
    _tivio = tivio;
    return subscribeToTivioWidgets();
  }

  subscribeToTivioWidgets() {
    return _tivio.subscribeToWidgets((widget) {
      setState(() {
        tivioWidgets[widget.id] = widget;
      });
    });
  }

  fetchTivioWidgets({int count = 10}) async {
    return TivioDataPagination<TivioDataWidget>([], false);
  }

  @override
  void dispose() {
    super.dispose();
    if (_tivio != null) {
      _tivio.unsubscribeToWidgets();
    }
  }
}
