library tivio;
import 'dart:async';
import 'bridge.dart';
import 'dto.dart';
import 'player/tivio_player_wrapper.dart';
export 'mixins/tivio_widgets.dart';
export 'mixins/tivio_channels.dart';
export 'mixins/tivio_sections.dart';
export 'mixins/tivio_videos.dart';
export 'dto.dart';
export 'player/tivio_player.dart';
export 'player/tivio_player_controller.dart';
export 'player/tivio_player_input_source.dart';
export 'player/tivio_player_wrapper.dart';

class Tivio {
  final String _appId;
  final Bridge _bridge = Bridge();

  Tivio(this._appId);

  Future<Tivio> init () async {
    await _bridge.init(_appId);
    return this;
  }

  Future<TivioDataWidget> getWidget (String id) => _bridge.getWidget(id);

  Future<TivioPlayerWrapper> getPlayer (String id) => _bridge.getPlayer(id);

  subscribeToWidgets (Function(TivioDataWidget) callback) {
    return _bridge.subscribeToWidgets(callback);
  }

  unsubscribeToWidgets () {
    _bridge.unsubscribeToWidgets();
  }
}

Future<Tivio> initTivio (String secret) {
  return Tivio(secret).init();
}
